package com.example.study_parsing;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;

public class IntroActivity extends Activity {
	public static HashMap<Integer, HankyungData> HANKYUNG_MAP;
	
	private HankyungData hankyung;
	private String tagName;
	private String parsing_data;
	
	private ArrayList<String> titleArr;
	private ArrayList<String> linkArr;
	private ArrayList<String> textArr;
	
	private XmlPullParserFactory factory;
	private XmlPullParser xpp;
	
	private int eventType = 0;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_intro);
		
		HANKYUNG_MAP = new HashMap<Integer, HankyungData>();
		
		titleArr = new ArrayList<String>();
		linkArr = new ArrayList<String>();
		textArr = new ArrayList<String>();
		
		NetworkThread nThread = new NetworkThread();
		nThread.setDaemon(true);
		nThread.start();
	}
	
	Handler timeHandler = new Handler();
	Runnable introTimer = new Runnable() {
		public void run() {
			int size = titleArr.size() - 1;
			for (int i = 0; i < size; i++) {
				hankyung = new HankyungData(titleArr.get(i), textArr.get(i), linkArr.get(i));
				HANKYUNG_MAP.put(i + 1, hankyung);
			}
			
			Intent intent = new Intent(IntroActivity.this, MainActivity.class);
			finish();
			startActivity(intent);
		}
	};
	
	public void stream(){
		HttpURLConnection urlConnection = null;
		try {
			URL url = new URL("http://rss.hankyung.com/new/news_industry.xml"); //Ѱ  īװ
							//http://www.hankyung.com/news/industry/  <-- xml ƴ   ּ
			urlConnection = (HttpURLConnection) url.openConnection();
			InputStream in = urlConnection.getInputStream();
			InputStreamReader isr = new InputStreamReader(in);
			BufferedReader buf = new BufferedReader(isr);
			StringBuffer sb = new StringBuffer();
			
			while (true) {
				String readLine = buf.readLine();
				if (readLine == null)
					break;
				sb.append(readLine);
				sb.append("\n");
			}
			parsing_data = sb.toString();			
			parsing();

		}
		catch (Exception e) {
			Log.e("fureun", "stream Exception : " + e.toString());
		}
		finally {
			if (urlConnection != null) {
				urlConnection.disconnect();
				
			}
		}
	}
	
	
	private void parsing() {
		try{
			factory = XmlPullParserFactory.newInstance();
			factory.setNamespaceAware(true);
			xpp = factory.newPullParser();
			xpp.setInput(new StringReader (parsing_data));
			eventType = xpp.getEventType();
			
			while (eventType != XmlPullParser.END_DOCUMENT) {
			
				if (eventType == XmlPullParser.START_TAG) {
				String itemChecker = xpp.getName();
					if (itemChecker.equals("item")) {
						
						while (eventType != XmlPullParser.END_DOCUMENT) {
							
							if (eventType == XmlPullParser.START_TAG) {
								tagName = xpp.getName();
							}
							else if (eventType == XmlPullParser.TEXT) {
								
								if (tagName!=null) {
									if (xpp.getText().trim().toString().length() > 5) {
									
										if (tagName.equals("title")) {
											titleArr.add(xpp.getText().trim().toString());
										}
										
										else if (tagName.equals("link")) {
											textArr.add(xpp.getText().trim().toString());
										}
										
										else if (tagName.equals("description")) {
											linkArr.add(xpp.getText().trim().toString());
										}
									}
								}
							}
							eventType = xpp.next();
						}
					}	
				}
				eventType = xpp.next();
			}
			timeHandler.postDelayed(introTimer, 3000);
		}
		catch (Exception e) {
			Log.e("fureun", "Parsing Exception : " + e.toString());
		}
	}
	
	class NetworkThread extends Thread {
		public void run() {
			stream();
		}
	}
}
